/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.desk.controller;

import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.github.xiaoymin.knife4j.annotations.ApiSort;
import io.swagger.annotations.*;
import lombok.AllArgsConstructor;
import org.springblade.bank.postchange.vo.PostChangeVO;
import org.springblade.common.cache.SysCache;
import org.springblade.common.utils.hangxin.HangxinUtil;
import org.springblade.common.utils.hangxin.bean.HangxinResultBean;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.datascope.annotation.DataAuth;
import org.springblade.core.datascope.enums.DataScopeEnum;
import org.springblade.core.launch.constant.AppConstant;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tenant.annotation.TenantDS;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.modules.desk.entity.Notice;
import org.springblade.modules.desk.service.INoticeService;
import org.springblade.modules.desk.vo.NoticeVO;
import org.springblade.modules.desk.wrapper.NoticeWrapper;
import org.springblade.modules.publishevent.event.HangxinNoticeEvent;
import org.springblade.modules.system.entity.User;
import org.springblade.modules.system.service.IUserService;
import org.springframework.context.event.EventListener;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * 控制器
 *
 * @author Chill
 */
@TenantDS
@RestController
@RequestMapping(AppConstant.APPLICATION_DESK_NAME + "/notice")
@AllArgsConstructor
@ApiSort(2)
@Component
@Api(value = "用户博客", tags = "博客接口")
public class NoticeController extends BladeController {

	private final INoticeService noticeService;
	private final IUserService userService;

	private HangxinUtil hangxinUtil;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入notice")
	public R<NoticeVO> detail(Notice notice) {
		Notice detail = noticeService.getOne(Condition.getQueryWrapper(notice));
		return R.data(NoticeWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiImplicitParams({
		@ApiImplicitParam(name = "category", value = "公告类型", paramType = "query", dataType = "integer"),
		@ApiImplicitParam(name = "title", value = "公告标题", paramType = "query", dataType = "string")
	})
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入notice")
	public R<IPage<NoticeVO>> list(@ApiIgnore @RequestParam Map<String, Object> notice, Query query) {
		IPage<Notice> pages = noticeService.page(Condition.getPage(query), Condition.getQueryWrapper(notice, Notice.class));
		return R.data(NoticeWrapper.build().pageVO(pages));
	}

	/**
	 * 多表联合查询自定义分页
	 */
	@GetMapping("/page")
	@ApiImplicitParams({
		@ApiImplicitParam(name = "category", value = "公告类型", paramType = "query", dataType = "integer"),
		@ApiImplicitParam(name = "title", value = "公告标题", paramType = "query", dataType = "string")
	})
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入notice")
	public R<IPage<NoticeVO>> page(@ApiIgnore NoticeVO notice, Query query) {
//		notice.setCreateUser(AuthUtil.getUserId());
		notice.setCurrentUserId(AuthUtil.getUserId());
		IPage<NoticeVO> pages = noticeService.selectNoticePage(Condition.getPage(query), notice);

		List<NoticeVO> list = new ArrayList<>();
		for (int i = 0; i < pages.getRecords().size(); i++) {
			Notice item = pages.getRecords().get(i);
			NoticeVO noticeVO = Objects.requireNonNull(BeanUtil.copy(item, NoticeVO.class));

			List<String> roleName = SysCache.getRoleNames(noticeVO.getRoleId());
			List<String> deptName = SysCache.getDeptNames(noticeVO.getDeptId());
			noticeVO.setRoleName(Func.join(roleName));
			noticeVO.setDeptName(Func.join(deptName));
			List<User> userList = userService.getUsersByIds(noticeVO.getTargetIds());
			List<String> targetNames = userList.stream().map(user -> user.getName()).collect(Collectors.toList());
			String join = StringUtil.join(targetNames, " | ");
			noticeVO.setTargetNames(join);
			list.add(noticeVO);
		}

		pages.setRecords(list);
		return R.data(pages);
	}

	@GetMapping("/myNoticePage")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入notice")
	public R<IPage<NoticeVO>> myNoticePage(@ApiIgnore NoticeVO notice, Query query) {
//		notice.setCreateUser(AuthUtil.getUserId());
		notice.setCurrentUserId(AuthUtil.getUserId());
		IPage<NoticeVO> pages = noticeService.selectMyNoticePage(Condition.getPage(query), notice);

		List<NoticeVO> list = new ArrayList<>();
		for (int i = 0; i < pages.getRecords().size(); i++) {
			Notice item = pages.getRecords().get(i);
			NoticeVO noticeVO = Objects.requireNonNull(BeanUtil.copy(item, NoticeVO.class));

			List<String> roleName = SysCache.getRoleNames(noticeVO.getRoleId());
			List<String> deptName = SysCache.getDeptNames(noticeVO.getDeptId());
			noticeVO.setRoleName(Func.join(roleName));
			noticeVO.setDeptName(Func.join(deptName));
			List<User> userList = userService.getUsersByIds(noticeVO.getTargetIds());
			List<String> targetNames = userList.stream().map(user -> user.getName()).collect(Collectors.toList());
			String join = StringUtil.join(targetNames, " | ");
			noticeVO.setTargetNames(join);

			Integer hadRead = 0;
			if (noticeVO.getReadIds() != null && noticeVO.getReadIds().contains(AuthUtil.getUserId()+"")){
				hadRead = 1;
			}
			noticeVO.setHadRead(hadRead);

			if (noticeVO.getType().equals("0")){
				noticeVO.setCreateUserName("系統");
			}else{
				User user = userService.getById(noticeVO.getCreateUser());
				noticeVO.setCreateUserName(user.getName());
			}

			list.add(noticeVO);
		}

		pages.setRecords(list);
		return R.data(pages);
	}



	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入notice")
	public R save(@RequestBody Notice notice) {
		return R.status(noticeService.save(notice));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入notice")
	public R update(@RequestBody Notice notice) {
		return R.status(noticeService.updateById(notice));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入notice")
	public R submit(@RequestBody Notice notice) {

		if (StringUtil.isBlank(notice.getTargetIds())){
			List<String> deptIds = Func.toStrList(notice.getDeptId());
			List<String> roleIds = Func.toStrList(notice.getRoleId());
			List<User> userList = userService.getUsersByDeptIdsRoleIds(deptIds, roleIds);
			List<Long> userIdList = userList.stream().map(user -> user.getId()).collect(Collectors.toList());
			String join = StringUtil.join(userIdList);
			notice.setTargetIds(join);
		}
		return R.status(noticeService.saveOrUpdate(notice));
	}

	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入notice")
	public R remove(@ApiParam(value = "主键集合") @RequestParam String ids) {
		boolean temp = noticeService.deleteLogic(Func.toLongList(ids));
		return R.status(temp);
	}

	/**
	 * 已讀記錄
	 */
	@PostMapping("/setHadRead")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "已讀記錄", notes = "传入notice")
	public R setHadRead(@ApiParam(value = "主键集合") @RequestParam String ids) {
		List<Long> longs = Func.toLongList(ids);
		longs.forEach(id -> {
			Notice notice = noticeService.getById(id);
			if (notice.getReadIds() == null){
				notice.setReadIds(AuthUtil.getUserId()+"");
			}else{
				notice.setReadIds(notice.getReadIds() + "," + AuthUtil.getUserId());
			}
			noticeService.updateById(notice);
		});
		return R.status(true);
	}

	/**
	 * 已讀記錄
	 */
	@PostMapping("/setAllHadRead")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "已讀記錄", notes = "传入notice")
	public R setAllHadRead() {
		List<Notice> list = noticeService.selectMyNoticeAll();

		list.forEach(notice -> {
			if (notice.getReadIds() == null){
				notice.setReadIds(AuthUtil.getUserId()+"");
			}else{
				notice.setReadIds(notice.getReadIds() + "," + AuthUtil.getUserId());
			}
		});
		return R.status(noticeService.updateBatchById(list));
	}

	/**
	 * test
	 */
	@PostMapping("/testNotice")
	@ApiOperationSupport(order = 10)
	@ApiOperation(value = "test", notes = "传入mocode")
	public R testNotice(@ApiParam(value = "主键集合") @RequestParam String mocode) {
		List<String> ehrList = Func.toStrList(mocode);
		String title = "test-有關 （副本認證章13） 的交接登記已於2021-10-22完成；交出人：張三；接收人：李4 業務印章交接登記表";
		HangxinResultBean hangxinResultBean = hangxinUtil.sendMsg(StringUtil.join(ehrList, "|"), "提示進度", title);
		return R.data(hangxinResultBean);
	}


}
